# -----------------------------------
# TK Formgen
# Vesion 0.0.6 26 September 2019
# -----------------------------------
if {![info exists folder]} {
      append folder [file dirname [file normalize [info script ]]] "/"
} 
package require Tk
namespace eval Commons {
    variable tooltip 1
	variable customEvent ""
}
if {[catch {package require tooltip}]} {
    # Set up a dummy interface to work around the absence
    set ::Commons::tooltip 0
}
append src1 $folder "fGenProc.tcl"
source $src1
set fgVarContainer ""
proc formGen {parameters} {
	lassign $parameters params callBack customEvent
	global wReference defaultsMap fieldsTypeMap controlsMap fgVarContainer scaleMap keyValueMap rdbMap QSMap numericFieldsList ; # outputData
	global bgColor bgButton Elem fields QSMap
	if {[file exists $params] == 1} {
		set fp [open $params r]
		set params [fg_Unicode [read $fp]]
		close $fp
	}	
	if {![info exists callBack]} {
      puts "No callBacks"
	}
	regsub -all {;\s*} $params ";" params; # remove CR LF after semicolon
	set conversionTypeMap [dict create "TEXT" "T" "PASSWORD" "P" "DEFAULTS" "DEFAULT" "RDB" "R"\
						   "CHECK" "CKB" "LABELS" "LABEL" "HIDDEN" "H" "VALIDATE" "V" "COMMENT" "C"\
						   "REQUIRED" "REQ" "SCALE" "S" "QSCALE" "QS" "BACKGROUND" "GROUND"\
						   "FILE" "F" WFILE "WF" "FOLDER" "D" "AREA" "A"]
	set defaultLengthsMap [dict create "T" 20 "N" 8 "IN" 7 "DN" 10 "P" 16 "R" 12 "S" 180 "QS" 150 "TIME" 10 "A" 5 "F" 40 "WF" 40 "D" 30]
	set numericFieldsList [list "N" "IN" "DN" "S"]
	set defaultsMap [dict create]
	set ::Commons::customEvent $customEvent
	set ::Commons::callBack $callBack
	set ::Commons::requiredButtons 0
	set ::Commons::source ""
	set requiredButtonsMap [dict create CMB 100 B 0 C 1 H 0]
	set fg_title "Tcl - Tk Form Generator"	
#	if event handlers are in another script
	regsub {::} $callBack "?" callBack
	set cEvent [split $callBack "?"]
	if {[llength $cEvent] == 2} {
		source [lindex $cEvent 0]
		set ::Commons::callBack [lindex $cEvent 1]
		set ::Commons::source [lindex $cEvent 0]
	}
	regsub {::} $customEvent "?" customEvent
	set cEvent [split $customEvent "?"]
	if {[llength $cEvent] == 2} {
		if {$::Commons::source != [lindex $cEvent 0]} {source [lindex $cEvent 0]}		
		set ::Commons::customEvent [lindex $cEvent 1]
	}
	set buttonsMap [dict create "fg_Ok" [list "Ok" [list fg_Exit Ok]] \
								"fg_Cancel" [list "Cancel" [list fg_Exit Cancel]] "fg_Reset" {"Reset" "fg_Restore"}]
	set widgets [dict create]
	set controlsMap [dict create]
	set fields {}
	set labelStick "w"
	set afterLabel ""
	set theme ""
	set bgColor [ttk::style lookup . -background]
	set maxTextWidth 50
	set allCommands [split [string trim $params "{}"]  ";"]
	set QSMap [dict create]
	set afterMap [dict create]	; # map of widgets to after key: widget to after value: widget aftered
	set afterWidgetMap [dict create] ; # map of widgets aftered key: widget aftered value: list of widget to after
	set Elem [dict create]
	foreach x $allCommands {
		set widget [split $x ","]
		set llWidget [llength $widget]
		for {set j 0} {$j < 5} {incr j} {
			lappend widget {}
			if {$j > 1 && $j <= $llWidget} {set widget [lreplace $widget $j $j [fg_deMask [lindex $widget $j]]]}
		} 
		set type [string toupper [string trim [lindex $widget 0]]]
		set widget [lreplace $widget 0 0 $type] 
		set type [getDictValue $conversionTypeMap $type $type]
		set widget [lreplace $widget 0 0 $type]
		if {[string range $type 0 0] == "#"} continue
		switch $type {
			AFTER {
				dict set afterMap [lindex $widget 1] [lindex $widget 2]
				dict set afterWidgetMap [lindex $widget 2] 0
			}
			DEFAULT {
				foreach default $widget {
					set KeyValue [split $default ":"]
					if {[llength $KeyValue] == 3} { 
						set KeyValue [lreplace $KeyValue 1 1 "[lindex $KeyValue 1]:[lindex $KeyValue 2]"] ;# if there is :
						}
					if {[llength $KeyValue] > 1} {
						set value [fg_deMask [lindex $KeyValue 1]]
						dict set defaultsMap [lindex $KeyValue 0] $value
					}
				}
			}
			LABEL {
				if {[string tolower [lindex $widget 1]] == "right"} {set labelStick "e"}
				set afterLabel [lindex $widget 2]
			}
			REQ {
				# updateControls [list [join [list "$varName is " {^\[+-\]?(0|\[1-9\])\\d*$}] ""] "Not valid number"]
				for {set i 1} {$i < [llength $widget]} {incr i} { 
					if {[lindex $widget $i] != ""} {updateControls [list [join [list [lindex $widget $i] " is required"] "" ] "Required"]}
				}
			}
			GROUND {
				if {[lsearch [ttk::style theme names] [lindex $widget 2]] != -1} {set theme [lindex $widget 2]}
				if {[lindex $widget 1] != ""} {set bgColor [lindex $widget 1]}
			}
			TITLE {
				set fg_title [lindex $widget 1]
			}
			V {
				set value [fg_deMask [lindex $widget 1]]
				set widget [lreplace $widget 1 1 $value]
				updateControls [lreplace $widget 0 0]
			}
			"" {}	;# empty
			default {
				if {$type == "C"} {
					set widget [lreplace $widget 4 4 [lindex $widget 1]]	;# comment
					set widget [lreplace $widget 3 3 [string length [lindex $widget 1]]]	;# lengtc
					set widget [lreplace $widget 1 1 fg_Comment]
				}
				if {$type == "H"} {
					dict set defaultsMap [lindex $widget 1] [lindex $widget 2]
				}
				if {[lindex $widget 2] == ""} { 	;# label lacks
					set widget [lreplace $widget 2 2 [lindex $widget 1]] 
				}
				if {[lindex $widget 3] == ""} {		;# length lacks
					set widget [lreplace $widget 3 3 [getDictValue $defaultLengthsMap $type 20]]
				}
				lappend fields $widget
				dict set fieldsTypeMap [lindex $widget 1] $type
			}
		}
	}
	if {$theme != ""} {	; # winnative clam alt default classic vista xpnative
		ttk::style theme use $theme
	}
	if {[winfo exists .fg] == 1} {;	# form calling form
		destroy .fg
	}
	wm title . $fg_title
	set bgButton [ttk::style lookup fg.TButton -background]
	ttk::style configure fg.TCheckbutton -background $bgColor
	ttk::style configure fg.TFrame -background $bgColor
	ttk::style configure fg.TLabel -background $bgColor -foregraund black
	ttk::style configure fg.TRadiobutton -background $bgColor -foregraund black
	ttk::style configure little.TButton -font "helvetica 14"  -foreground blue -width 2 -bg $bgColor
	ttk::style configure fg.TButton -font "helvetica 10"  -foreground blue -bg green
	grid [ttk::frame .fg -padding "3 3 12 12" -relief ridge -style fg.TFrame] -column 0 -row 0 -sticky nwes	
	grid columnconfigure . 0 -weight 1; grid rowconfigure . 0 -weight 1
	set row 0
	set index -1
	foreach widget $fields {
		incr index
		lassign $widget type varName lbl length extra
		if {$type == "H"} {continue}
		set name [string tolower $varName];	# name for paths
		set ::Commons::requiredButtons [expr {$::Commons::requiredButtons + [getDictValue $requiredButtonsMap $type 200]}]
		if {![dict exists $afterMap $varName] && $type != "B"} {incr row}
		if {$type == "C"} {
			grid [ttk::label .fg.fgl_$name$index -text $extra -style fg.TLabel] -in .fg -column 0 -columnspan 2 -row $row -sticky we
			continue
		}
		dict set Elem $varName $index
		dict set wReference .fg.$name $varName ;# for link widgetName FieldName
		dict set wReference $varName .fg.$name ;# for link FieldName widgetName
		grid [ttk::frame .fg.after_$name -style fg.TFrame] -in .fg -column 1 -row $row -sticky w
		switch $type {
			A {
				text .fg.$name -width $maxTextWidth -height $length
			}
			B {
				if {[dict exists $afterMap $varName]} {
					set cmd "fg_afterButton $extra $varName"
					if {$extra == ""} {
						set cmd [list fg_Exit $varName]
					}
					set afterName [dict get $afterMap $varName]
					set afterNameLower [string tolower $afterName]
					if {[regexp ".(gif|png)$" $lbl -nocase]} {							
						image create photo icon -file $lbl
						ttk::label .fg.$afterNameLower$name -image icon
						bind .fg.$afterNameLower$name <1> $cmd

					} else {
#						ttk::button .fg.$afterNameLower$name -text " $lbl " -command $cmd -style little.TButton
						ttk::label .fg.$afterNameLower$name -text " $lbl " -background $bgColor -font {Helvetica -14 bold} -borderwidth 2 -relief raised
						bind .fg.$afterNameLower$name <Enter> {%W configure -background silver}
						bind .fg.$afterNameLower$name <Leave> {%W configure -background $bgColor}
						bind .fg.$afterNameLower$name <1> $cmd
					}
					set n [dict get $afterWidgetMap $afterName]
					grid .fg.$afterNameLower$name -in .fg.after_$afterNameLower -column [expr $n + 1] -row 0 -sticky w
					dict set afterWidgetMap $afterName [expr $n + 1]
				} else {
					set l [getDictValue $buttonsMap $varName ""]
					if {$l != ""} {
						lset l 0 $lbl
						dict set buttonsMap $varName $l
					} else {
						# remove Ok button
						set buttonsMap [dict remove $buttonsMap "fg_Ok"]
						if {$extra != ""} {
							dict set buttonsMap $varName [list $lbl [list fg_Exit [list $varName $extra]]]
						} else {
							dict set buttonsMap $varName [list $lbl [list fg_Exit $varName]]
						}
						
					}
				}
				continue
			}
			N - IN - DN - T - TIME {
				if {$type == "T" && $length > $maxTextWidth} {
					text .fg.$name -width [expr $maxTextWidth] -height [expr $length/$maxTextWidth]
					dict set fieldsTypeMap $varName "A"	; # area type
				} else {ttk::entry .fg.$name -width $length}
				# ^[-+]?(0|[1-9]\d*)(\.\d+)?$
				if {$type == "N"} {updateControls [list [join [list "$varName is " {^\[+-\]?\[1-9\]\\d*$}] ""] "Not valid number"]}
				if {$type == "IN"} {updateControls [list [join [list "$varName is " {^\[1-9\]\\d*$}] ""] "Not valid integer number"]}
				if {$type == "DN"} {updateControls [list [join [list "$varName is " {^\[-+\]?(0|\[1-9\]\\d*)(\\.\\d+)?$}] ""] "Not valid decimal number"]}
				if {$type == "TIME"} {updateControls [list [join [list "$varName is " {^(\[01\]\[0-9\]|2\[0-3\]):\[0-5\]\[0-9\]:\[0-5\]\[0-9\]$}] ""] "Not valid time"]}
				if {$type != "T"} {
					.fg.$name configure -justify right
				}
				if {$extra != "" && $::Commons::tooltip == 1} {tooltip::tooltip .fg.$name $extra}
			}
			F - WF - D {
				ttk::frame .fg.$name -style fg.TFrame
				grid [ttk::entry .fg.f$name -width $length] -in .fg.$name -column 0 -row 0
				ttk::label .canvas$name -text "  ...  " -background $bgColor -font {Helvetica -14 bold} -borderwidth 2 -relief raised
				bind .canvas$name <Enter> {%W configure -background silver}
				bind .canvas$name <Leave> {%W configure -background $bgColor}
				bind .canvas$name <1> [list fg_File $varName]
				grid .canvas$name -in .fg.$name -column 1 -row 0
				dict set wReference .fg.f$name $varName ;# for link widgetName FieldName
				dict set wReference $varName .fg.f$name ;# for link FieldName widgetName
			}
			P {
				ttk::entry .fg.$name -width $length -show *
				if {$extra != "" && $::Commons::tooltip == 1} {tooltip::tooltip .fg.$name $extra}
			}
			R {
				set lst [splitKeyValue [lindex $widget 1] [lindex $widget 4]]
				ttk::frame .fg.$name -style fg.TFrame
				set nRdb [llength $lst]
				ttk::radiobutton .fg.$name$nRdb -text "" -variable $varName -value "" -style fg.TRadiobutton
				grid .fg.$name$nRdb -in .fg.$name -column 0 -row 0
				for {set i 0} {$i < [llength $lst]} {incr i} {							
					set value [lindex $lst $i]
					set keyValue [getDictValue $keyValueMap "$varName$value" ""]
					
					ttk::radiobutton .fg.$name$i -text $value -variable $varName -value $keyValue -style fg.TRadiobutton
					if {[regexp ".(gif|png)$" $value -nocase]} {							
						image create photo icon$i -file $value
						.fg.$name$i configure -image icon$i 
					}
					grid .fg.$name$i -in .fg.$name -column $i -row 0
					dict set rdbMap "$varName$keyValue" .fg.$name$i
					dict set wReference .fg.$name$i $varName ;# for link widgetName FieldName
				}		
			}
			CMB - CMT {
				set lst [splitKeyValue [lindex $widget 1] [lindex $widget 4]]
				if {$type == "CMB"} {
					ttk::combobox .fg.$name -width $length -values $lst -justify left -state readonly
				} else {
					ttk::combobox .fg.$name -width $length -values $lst			
				}
				bindtags .fg.$name [linsert [bindtags .fg.$name] 1 myCombo]
			}
			CKB {
				ttk::checkbutton .fg.$name -width $length -text [lindex $widget 4] -style fg.TCheckbutton -offvalue "0" -onvalue "1" -variable $varName
			}
			S - QS {
				set fgVarContainer $name
				namespace eval fg {variable fgls_$fgVarContainer ""}
				if {$type == "QS"} {
					set lst [splitKeyValue [lindex $widget 1] [lindex $widget 4]]
					dict set QSMap $varName $lst
					set scaleParms [list 0 [expr [llength $lst] * 10 - 1]]
				} else {
					set scaleParms [expr {$extra == "" ? {0 100 0} : [split $extra " "]}]
				}
				ttk::scale .fg.$name -length $length -from [lindex $scaleParms 0] -to [lindex $scaleParms 1]
				ttk::label .fg.fgls_$name -width 6 -textvariable fg::fgls_$name -style fg.TLabel
				bindtags .fg.$name [linsert [bindtags .fg.$name] 1 myScale]
				set delta [expr {abs([lindex $scaleParms 1] - [lindex $scaleParms 0])}]
				set x [expr {floor(log10(abs($delta)))-1}]
				set x [expr {$x < 1 ? abs($x)+1 : 0}]
				if {[llength $scaleParms] == 3} {set x [lindex $scaleParms 2]}
				dict set scaleMap $varName $x
			}
			default {}
		}
		if {![dict exists $afterMap $varName]} {		
			if {$type != "C"} {
				grid .fg.$name -in .fg.after_$name -column 0 -row 0 -sticky w
				grid [ttk::label .fg.fgl_$name -text "$lbl$afterLabel" -style fg.TLabel] -in .fg -column 0 -row $row -sticky $labelStick
				if {$type == "S" || $type == "QS"} {grid .fg.fgls_$name -in .fg.after_$name -column 1 -row 0 -sticky w}
			}
		} else {
			set afterName [string tolower [dict get $afterMap $varName]]
			grid .fg.$name -in .fg.after_$afterName -column 1 -row 0 -sticky w
		}
	}
	# add buttons
	incr row
	ttk::frame .fg.buttons -style fg.TFrame
	set column 0
	if {$::Commons::requiredButtons < 200} {
		set buttonsMap [dict remove $buttonsMap "fg_Ok"]
		set buttonsMap [dict remove $buttonsMap "fg_Reset"]
		if {$::Commons::requiredButtons > 99} {set buttonsMap [dict remove $buttonsMap "fg_Cancel"]}
	}
	dict for {button parms} $buttonsMap {
		incr column
		lassign $parms caption procedure
		grid [ttk::button .fg.buttons.[string tolower $button] -text $caption -command $procedure -style fg.TButton] -column $column -row 0 -sticky we
	}
	grid .fg.buttons -column 0 -columnspan 2 -row $row
	foreach w [winfo children .fg] {grid configure $w -padx 3 -pady 3}
	fg_eventsHandler [list Start]
	fg_Restore	;# set default values
	bind myScale <B1-Motion> {
		set name [dict get $wReference %W]
		set wName [string tolower $name]
		set decimals [dict get $scaleMap $name]
		set type [getDictValue $fieldsTypeMap $name "T"]
		set value [%W get]
		if {$type == "QS"} {
			set lst [dict get $QSMap $name]
			set value [lindex $lst [expr int($value/10)]]
		} else {
			if {$decimals < 1} {set value [expr {int($value/pow(10,abs($decimals)))}]
			} else {
				set decimals [expr {pow(10,$decimals)}]
				set value [expr {int($value*$decimals)/$decimals}]
			}		
		}
		set fg::fgls_$wName $value
		fg_eventsHandler [list "Scale" %W $name]	; # [expr \$$name]		
	}
	bind myCombo <<ComboboxSelected>> {		
		set value [%W get]		
		set name [dict get $wReference %W]
		if {$value != ""} {set value [getDictValue $keyValueMap "$name$value" $value]}
		fg_eventsHandler [list Select %W $name]
		if {$::Commons::requiredButtons < 200} {fg_Exit $name}
	}
	bind . <FocusOut> {				
		if {[dict exists $wReference %W]} {
			set name [dict get $wReference %W]
			set value ""
			switch [getDictValue $fieldsTypeMap $name "T"] {
				A - CKB - CMB - S - R {
				} 
				default {
					set value [%W get]
					set sErrors [controlField $name $value]
					if { $sErrors != ""} {signal $sErrors}
				}
			}
			fg_eventsHandler [list lFocus %W $name]
		}
	}
}
proc fg_eventsHandler {e} {
	if {$::Commons::customEvent != ""} {
		eval "$::Commons::customEvent [list $e]"
	}
}
proc fg_afterButton {procName button} {
	$procName $button
}
proc fg_Exit {params} {
	global Elem numericFieldsList fieldsTypeMap ; # outputData
	set button [lindex $params 0]
	set callBack $::Commons::callBack
	if {[llength $params] == 2} {set callBack [lindex $params 1]}
	set widgets [dict create "fg_Button" $button]
	fg_eventsHandler [list "End" $button]
	if {$button != "Cancel"} {
		# control data
		set sErrors ""
		foreach id [dict keys $Elem] {
			append sErrors [controlField $id [valueOf $id]]
		}
		if {$sErrors != ""} {
			signal $sErrors
			return
		}
		set json "\{\"fg_Button\": \"$button\",\n"; 	# jsonStart
		foreach id [dict keys $Elem] {
			set type [getDictValue $fieldsTypeMap $id "T"]
			set a "\""
			set value [valueOf $id]
			dict set widgets $id $value
			if {[lsearch $numericFieldsList $type] != -1} {
				append a $id "\": " [expr {$value == "" ? 0 : $value}]
			} else {
				append a $id {": "} [fg_JasonMask $value] "\""
			}
			lappend lst $a
		}
		append json [join $lst ",\n"] "\}"
	} else {
		set json "\{\"fg_Button\": \"$button\"\}"
	}
	set outputData [expr {[info procs $callBack] != "" ? "" : $callBack}]
	if {$outputData != ""} {
		set suffix [string tolower [file extension $outputData]]
		set chan [open $outputData w]
			if {$suffix == ".json"} {
				puts $chan $json
				exit				
			} else {
				foreach id [dict keys $widgets] {
					puts $chan "$id\t : [valueOf $id]"
				}
				return $json
				exit
			}
		close $chan
	} else {
		destroy .fg
		if {[info procs $callBack] != "" && $button != "Cancel"} {
			$callBack $widgets
		} else {
			puts $json
			exit
		}
	}
}
# direct call -------------------------------------------
if {[llength $argv] > 0} {
	formGen $argv
}