namespace eval gb {
	variable FaRo "FaRo Farmacie Romene"
}
proc insertDrugForm {frm} {
	formGen [list $frm cBack handleEvents]
	place .fg -x 30 -y 45
}
proc informazione {frm} {
	fg_signal "Inserire le prime letter del farmaco e premere >" $::gb::FaRo 0
}
proc listDrugs {type} {
	set t "Genera EXCEL file"
	set h "H,fnz,E"
	if {$type != "EXCEL"} {
		set t "Lista farmaci"
		set h "H,fnz,S"
	}
	if {[winfo exists .fg] == 1} {destroy .fg}
	set frm "Title,FaRo - $t;Ground,silver;
				CMB,Lot,Lotto;
				B,Go,Ok,,mostra;
				$h;"
	set cmb [db eval {SELECT Lot FROM Drugs GROUP BY Lot}]
	append frm "Defaults,Lot:[lindex $cmb [expr [llength $cmb] - 1]];"
	formGen [list $frm]
	place .fg -x 30 -y 45
	fg_setCombo Lot "[join $cmb "|"]"
	fg_Restore
}
proc mostra {data} {	# visulizza dati
	global db
	set Lot [getDictValue $data Lot 0]
	if {[getDictValue $data fnz ""] == "S"} {	# lista e mdifica lotto
		listData $Lot
	} else {
		# (de)genera file csv EXCEL
		set fileName "Lot$Lot.csv"
		set csvfile [open $fileName w]		
		set header 0
		set countExported 0
		db eval "SELECT * FROM Drugs WHERE Lot = $Lot ORDER BY Name" values {			
			if {$header == 0} {
				incr header
				set headers [split $values(*) " "]
				puts $csvfile [csv::join $headers ";"]
				puts "[csv::join $headers ";"]"
			}
			set lst []
			incr countExported
			foreach item $headers {
				lappend lst $values($item)
			}
			puts $csvfile [csv::join $lst ";"]
			#			puts $outfile [csv::join [list $row ";"]]
		}
		close $csvfile
		fg_signal "File $fileName\nLotto $Lot, $countExported farmaci" $::gb::FaRo 3000
	}
}
##+##########################################################################
#
# simpleTable.tcl -- replacement of tktable for simple tables
# by Keith Vetter, October 2005
#	https://wiki.tcl-lang.org/page/Simple+Tktable
#
##############################################################################
proc modify {index} {
	global db table
	db eval "UPDATE Drugs SET Qty = $table($index,3) WHERE rowid = $table($index,4)"
	set signal "Modificato $table($index,3) $table($index,2)"
	if {[db  errorcode] != 0} {set signal "Errore: [db  errorcode]"}
	fg_signal $signal $::gb::FaRo 2000
}
proc cancel {index} {
	global db table
	set answer [tk_messageBox -message "Vuoi eliminare $table($index,2)?" \
        -icon question -type yesno]
	switch -- $answer {
		no return
		yes {
			db eval "DELETE FROM Drugs WHERE rowid = $table($index,4)"
			set w .table.r$index,2
			$w configure -fg silver
			set w .table.r$index,1
			$w configure -state disabled
			set w .table.r$index,0
			$w configure -state disabled
			puts "DELETE FROM Drugs WHERE rowid = $table($index,4)"
		}
	}
}
proc simpleTable {pathName args} {
	global table
	set legal {-rows -cols -titlerows -titlecols -format -variable}
    array set A {-rows 5 -cols 6 -titlerows 0 -titlecols 0 -format T}
    if {[llength $args] == 0} {
        error "usage: simpleTable pathName -variable varName ?options...?"
    } 
    set idx -1
    foreach {opt value} $args {
        if {[lsearch $legal $opt] == -1} {error "unknown option \042$opt\042"}
        if {[incr idx 2] >= [llength $args]} {error "value for \042$opt\042 missing"}
        set A($opt) $value
    }
    if {! [info exists A(-variable)]} {error "missing the \042-variable\042 option"}
    # Build table
    destroy $pathName
    frame $pathName
    for {set r 0} {$r < $A(-rows)} {incr r} {
        for {set c 0} {$c < $A(-cols)} {incr c} {
 			set w "$pathName.r${r},$c"
			set type [string toupper [lindex [lindex $A(-format) $c] 0]]
#	Types:	H 	= Header
#			B 	= Button
#			T 	= Text protect
#			N	= Numeric protect
#			NM	= Numeric modifiable
#			I	= Ignore
			if {$r == 0} {set type H}
			set anchor we
			set value $A(-variable)\($r,$c\)
			switch $type {
				B {
					button $w -textvariable $value -cursor hand2\
					-command "[lindex [lindex $A(-format) $c] 1] $r"
				}
				T {
					label $w -textvariable $value
					set anchor w
				}
				H {
					set bg SystemDisabledText 
					label $w  -textvariable $value			
				}
				N {
					set bg SystemDisabledText 
					label $w  -textvariable $value
					set anchor e
				}
				NM {
					set bg SystemDisabledText 
					entry $w  -textvariable $value -width 5 -justify right
					set anchor e
				}
				default {
				}
			}
			if {$type != "I"} {grid $w -row $r -column $c -sticky $anchor}
        }
    }
	return $pathName
}
proc listData {Lot} {
	global db table
	unset -nocomplain table
	array set table {
		0,0 Mod. 0,1 Elim. 0,2 "  Farmaco  " 0,3 "Quantità" 0,4 "" 0,5 "Scadenza"
	}
	set r 1
	db eval "SELECT rowid, Name, Qty, Deadline FROM Drugs WHERE Lot = $Lot ORDER BY Name" {
		set table($r,0) \u270E
		set table($r,1) \u2718
		set table($r,2) $Name
		set table($r,3) $Qty
		set table($r,4) $rowid
		set table($r,5) $Deadline
		incr r
	}
	frame .faro -relief raised -bd 2
	grid [simpleTable .table -variable table -rows $r -cols 6 -format "{B modify} {B cancel} T NM I T"] -in .faro -row 2 -column 0
	grid [label .faro.h -text "Lotto $Lot" -bg silver] -in .faro -row 1 -column 0 -sticky we
	grid [button .faro.close -text \u2718 -fg red -bd 0 -command "destroy .faro" -cursor hand2] -in .faro -row 0 -column 0 -sticky e
	# Lay them out
	place .faro -x 350 -y 45
}
proc cBack {data} {
	foreach id [dict keys $data] {puts "$id\t : [dict get $data $id]"}
}
proc saveDrug {button} {
	set fieldsList [list Name Category Action ActionCode Compound Qty Items Lot Store Deadline]
	foreach field $fieldsList {
		set $field [valueOf $field]
	}
	set sql "INSERT INTO Drugs (Name, Category, Action, ActionCode, Compound, Qty, Items,Lot, Store, Deadline) \
			VALUES('$Name', '$Category', '$Action', '$ActionCode', '$Compound', $Qty, $Items,'$Lot','$Store','$Deadline')"
	db eval $sql
	set signal "Inserito $Qty $Name"
		if {[db  errorcode] != 0} {set signal "Errore: [db  errorcode]"}
	fg_signal $signal $::gb::FaRo 2000
	fg_Restore
	setValue Lot $Lot
	setValue Store $Store
}
proc handleEvents {e} {
	lassign $e event path name
	switch $event {
		Start { 
			fg_setCombo Store "[join [db eval {SELECT Store FROM Stores ORDER BY Store}] "|"]"
		}
		Select {
			if {[string range $path 0 4] == ".fg.y"} {
				setValue Deadline "[valueOf $name] [string range $path 5 end]"
			} elseif {$name == "Names"} {
				set name [valueOf $name]
				set flds [db eval {SELECT Name,Category,Action,ActionCode,Compound FROM DrugsHandbook WHERE Name = $name}]
				lassign $flds Name Category Action ActionCode Compound
				setValue Name $Name
				setValue Category $Category
				setValue Action $Action
				setValue ActionCode $ActionCode
				setValue Compound $Compound
			}
		}
	}
}
proc getNames {button} {
	set n [valueOf "Name"]
	append n "%"
	set cmb [db eval {SELECT Name FROM DrugsHandbook WHERE Name LIKE $n ORDER BY Name}]
	fg_signal "trovati [llength $cmb] farmaci" $::gb::FaRo  1000
	fg_setCombo Names "[join $cmb "|"]"
}
append src [file dirname [file normalize [info script ]]] "/fGen.tcl"
source [set FilePath fGen.tcl]
set ask "Title,FaRo - Farmacie Romene;Ground,silver;
T,Name,Farmaco;
CMB,Names,Farmaci;
B,search,>,,getNames;
After,search,Name;
U,Action,Azione;
U,ActionCode,Action code,5;
U,Compound,Componenti,30;
U,Category,Categoria;
IN,Qty,Quantità;
IN,Items,Pezzi;
#After,Items,Qty;
T,Lot,Lotto,10;
CMB,Store,Magazzino;
Validate,Lot is required,il Lotto è necessario;
Required,Name;
B,Save,Inserisci,,saveDrug;
B,Info,?,,informazione;
After,Info,Names;
Validate,Qty > 0,la Quantità è necessaria;
Labels,Right, :;
T,Deadline,Scadenza,10;
Defaults,Qty:0,Items:0;
"
# set systemTime [clock seconds]
# append ask "H,hField,[clock format $systemTime];"
set dt [clock seconds]
for {set i 0} {$i<4} {incr i} {;	# append widget for deadline
	set year [clock format $dt -format %Y]
	append ask "CMB,Y$year,$year,,%#months;"
	set dt [clock add $dt 1 years]
}
package require csv
package require sqlite3
sqlite3 db FaRo.sqlite
set a [expr {int([winfo screenwidth .] * 0.5)}]
set b [expr {int([winfo screenheight .] * 0.5)}]
wm geometry . 400x300+[expr $a - 200]+[expr $b - 150]  ;# window is centered
update idletasks 
wm attributes . -topmost no
wm state . zoomed  ;# This command for Windows only
menu .mbar
. configure -menu .mbar
menu .mbar.fm -tearoff 0
.mbar add cascade -menu .mbar.fm -label File -underline 0
.mbar.fm add command -label Inserimento -underline 1 -command {insertDrugForm $ask}
.mbar.fm add command -label EXCEL -command {listDrugs EXCEL}
.mbar.fm add command -label Lista -command {listDrugs List}
.mbar.fm add separator
.mbar.fm add command -label Exit -underline 1 -command {exit}
menu .mbar.fh -tearoff 0
.mbar add cascade -menu .mbar.fh -label ?
.mbar.fh add command -label Info -command {fg_signal "Sermig\nVersion 1.1 Janvier 2021" $::gb::FaRo 3500}
insertDrugForm $ask